#include "tc_util.h"
// #include "util.h"


struct rev_sort
{
	tag_t rev;
	string id;
};

bool sort_by_rev(const rev_sort &a,const rev_sort &b)
{

	return a.id<b.id;
}
int ITEM_list_all_revs_alpha(tag_t item_tag,int *rev_cnt,tag_t **revs)
{

	Teamcenter::Item *item=BusinessObjectRef<Teamcenter::Item>(item_tag);
	vector<tag_t> tag_vec;
	vector<int> int_vec;
	vector<rev_sort> rev_vec;
	item->getTagArray("revision_list",tag_vec,int_vec);
	for(auto i=0;i<tag_vec.size();i++)
	{
		char *val;
		AOM_ask_value_string(tag_vec[i],"item_revision_id",&val);
		rev_sort sort;
		sort.rev=tag_vec[i];
		sort.id=val;
		rev_vec.push_back(sort);
	}
	sort(rev_vec.begin(),rev_vec.end(),sort_by_rev);
	*rev_cnt=rev_vec.size();
	*revs=(tag_t*)MEM_alloc(rev_vec.size()*sizeof(tag_t));
	for(auto i=0;i<rev_vec.size();i++)
	{
		(*revs)[i]=rev_vec[i].rev;
	}
	return 0;
}


bool isTypeOf(tag_t objtag, const char * type_name) {
	tag_t type = NULLTAG;
	TCTYPE_ask_object_type(objtag, &type);
	tag_t item_type = NULLTAG;
	TCTYPE_find_type(type_name, "", &item_type);
	bool is_type = false;
	if (item_type != NULLTAG) {
		logical isok = FALSE;
		TCTYPE_is_type_of(type, item_type, &isok);
		if (isok) {
			is_type = true;
		}
	}
	return is_type;
}

void ECHO(char *format, ...)
{
    char msg[2048];
    va_list args;

    va_start( args, format );
    vsprintf_s( msg, format, args );
    va_end( args );

    printf( msg );
    TC_write_syslog( msg );
}
/**
* ȡѡ
*/
int getPrefStrings1( const char *preference, TC_preference_search_scope_t scope, vector<string> &pref_vec  )
{
    int ifail = ITK_ok , i = 0, j = 0, k =0, num = 0;
	char **values;
    TC_preference_search_scope_t old_scope;
    ITKCALL( ifail = PREF_ask_search_scope( &old_scope) );
    ITKCALL( ifail = PREF_set_search_scope( scope ) );
    ITKCALL( ifail = PREF_ask_char_values( preference, &num, &values ) );
	//WriteLog("num=%d",num);
	for(i = 0; i < num; i++)
	{
		pref_vec.push_back(values[i]);
	}
	DOFREE(values);
    ITKCALL( ifail = PREF_set_search_scope( old_scope ) );
    return ifail;
}
//attr1:A001  map<attr1,A001>




